#if !defined(AFX_SETTINGSDLG_H__D81C36A3_DF24_48E6_AFD3_B64EFA95BFD3__INCLUDED_)
#define AFX_SETTINGSDLG_H__D81C36A3_DF24_48E6_AFD3_B64EFA95BFD3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SettingsDlg.h : header file
//

#include "patmif.h"
#include <winsock2.h>	// Windows and Winsock2 defines
#include <ws2atm.h>	
#include "sockatm.h"
#include "wdmatmif.h"
/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg dialog

class CSettingsDlg : public CDialog
{
// Construction
public:
	CSettingsDlg(CWnd* pParent = NULL);   // standard constructor
	~CSettingsDlg();
    CString m_Address[20];
    DWORD	m_OldReceiveBytes;
	DWORD	m_OldXmitBytes;
	// Dialog Data
	//{{AFX_DATA(CSettingsDlg)
	enum { IDD = IDD_TESTATM_SETTINGS };
	CComboBox	m_SelectDevice;
	CComboBox	m_LayerChoice;
	CComboBox	m_QOSChoice;
	int		m_ConnectionType;
	long	m_ACR;
	CString	m_Selector;
	UINT	m_PCR;
	DWORD	m_SCR;
	UINT	m_MBS;
	UINT	m_VCI;
	BYTE	m_VPI;
	BOOL	m_Receive;
	BOOL	m_Xmit;
	CString	m_Status;
	CString	m_ServerAddress;
	CString	m_LocalAddress;
	UINT	m_PacketSize;
	DWORD	m_XmitPackets;
	float	m_XmitRate;
	float	m_ReceiveRate;
	DWORD	m_ReceiveLost;
	DWORD	m_ReceivePackets;
	BOOL	m_SetQOS;
	UINT	m_AssignedVPI;
	UINT	m_AssignedVCI;
	CString	m_RemoteAddress;
	DWORD	m_ATMDeviceCount;
	DWORD	m_XmitBytes;
	DWORD	m_ReceiveBytes;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSettingsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
    BOOL  ConnectedState;
    BYTE  LocalATMAddress[20];
	// Generated message map functions
	//{{AFX_MSG(CSettingsDlg)
	afx_msg void OnCnxType();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeLayerChoice();
	afx_msg void OnSelchangeQosChoice();
	virtual BOOL OnInitDialog();
	afx_msg void OnStart();
	virtual void OnCancel();
	afx_msg void OnStop();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKillfocusEditPcr();
	afx_msg void OnKillfocusEditScr();
	afx_msg void OnCheckQos();
	afx_msg void OnSelchangeSelectDevice();
	//}}AFX_MSG
	ULONG IntervalCheck;
	BOOL CheckTestSanity();
   	afx_msg LRESULT OnInfoMessage(UINT wParam, LONG lParam);
	BOOL SetLoopbackMode(int DeviceNumber, BOOL bLoopbackMode);
	BOOL GetATMDevices(PATM_ADAPTER pAdapters, DWORD *pAdapterCount);
	int  StartATMConnection(PATM_SETTINGS pSettings,HWND DialogHandle);
	void StopATMConnection(int DeviceNumber);



    
	DECLARE_MESSAGE_MAP()
private:
	void SetSelections(void);
    void SetATMAddresses(void);
	BOOL ShutdownWindows(void);
	BOOL GetAdapterInformation();
    int  AdapterCount;
    PATM_ADAPTER pAdapters;
	int  TestDevice;

    ATM_SETTINGS InputSettings;


public:
	CString m_MacAddress;
private:
	BOOL m_Loopback;
	BYTE m_GFCValue;
	BYTE m_PTValue;
	BYTE m_CLPValue;
	CString m_ReceivedCellHeader;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETTINGSDLG_H__D81C36A3_DF24_48E6_AFD3_B64EFA95BFD3__INCLUDED_)
